import { world, BlockLocation } from "@minecraft/server";
import { ActionFormData, ModalFormData, MessageFormData } from "@minecraft/server-ui";
import * as GameTest from "@minecraft/server-gametest";
console.log("welcome");
//demo用，所以命名为lite版
var simPlayer_name_list = [];
var simPlayer_obj_list = [];
var test_tmp = "";

GameTest.register("simPlayer", "spawnPlayer", async (test) => {
  test_tmp = test;
  let simPlayer_name = "[Bot]P." + (simPlayer_name_list.length + 1);
  simPlayer_name_list.push(simPlayer_name);
  let simPlayer = test.spawnSimulatedPlayer(new BlockLocation(0, 2, 0), simPlayer_name);
  simPlayer_obj_list.push(simPlayer);
  simPlayer.runCommandAsync(`fill ~1 ~-1 ~ ~-2 ~-4 ~-2 dirt`);
})
  .maxTicks(999999999)
  .structureName("simPlayer:spawnPlayer");

world.events.beforeItemUse.subscribe((e) => {
  const player = e.source;
  if (e.item.typeId == "minecraft:emerald") {
    simPlayerMenu(player);
  }
});

function simPlayerMenu(player) {
  const form = new ActionFormData()
    .title("§1§l模拟玩家控制台 Lite")
    .body(
      "§a§o§l注意:生成模拟玩家将会在玩家附近生成4x3x4的结构体,为防止建筑等被破坏,请在合适位置生成模拟玩家！--yanhy2000"
    )
    .button("§l§0生成一个模拟玩家", "textures/ui/icon_steve")
    .button("§l§0模拟玩家传送选项", "textures/ui/servers")
    .button("§l§0踢出指定模拟玩家", "textures/ui/realms_red_x")
    .button("§l§0移除全部的模拟玩家与结构体", "textures/ui/refresh");

  form.show(player).then((result) => {
    if (result.selection === 0) {
      player.runCommandAsync(`gametest run simPlayer:spawnPlayer`);
    }
    if (result.selection === 1) {
      simPlayer_Teleport(player);
    }
    if (result.selection === 2) {
      if (simPlayer_name_list.length != 0) {
        let form = new ModalFormData().title("§r§a踢出模拟玩家§r").dropdown("选择踢出目标", simPlayer_name_list);
        form.show(player).then((res) => {
          test_tmp.removeSimulatedPlayer(simPlayer_obj_list[res.formValues[0]]);
          simPlayer_name_list.splice(res.formValues[0], 1);
          simPlayer_obj_list.splice(res.formValues[0], 1);
        });
      } else {
        let form = new MessageFormData()
          .title("§r§a踢出模拟玩家§r")
          .body("列表中无模拟玩家，如遇故障可尝试清空全部模拟玩家！")
          .button1("§4清空模拟玩家与结构体")
          .button2("关闭");
        form.show(player).then((res) => {
          if (res.selection == 1) {
            player.runCommandAsync(`gametest clearall`);
            simPlayer_name_list = [];
            simPlayer_obj_list = [];
          }
        });
      }
    }
    if (result.selection === 3) {
      player.runCommandAsync(`gametest clearall`);
      simPlayer_name_list = [];
      simPlayer_obj_list = [];
    }
  });
}

function simPlayer_Teleport(player) {
  if (simPlayer_name_list.length != 0) {
    let form = new ModalFormData()
      .title("§1§l模拟玩家控制台 Lite")
      .dropdown("选择传送目标", simPlayer_name_list)
      .toggle("自己->模拟玩家/自己<-模拟玩家");
    form.show(player).then((res) => {
      if (res.formValues[1] == false) {
        player.runCommandAsync('tp @s "' + simPlayer_name_list[res.formValues[0]] + '"');
      }
      if (res.formValues[1] == true) {
        player.runCommandAsync('tp "' + simPlayer_name_list[res.formValues[0]] + '" @s');
      }
    });
  } else {
    let form = new MessageFormData()
      .title("§1§l模拟玩家控制台")
      .body("列表中无模拟玩家，如遇故障可尝试清空全部模拟玩家！")
      .button1("§4清空模拟玩家与结构体")
      .button2("关闭");
    form.show(player).then((res) => {
      if (res.selection == 1) {
        player.runCommandAsync(`gametest clearall`);
        simPlayer_name_list = [];
        simPlayer_obj_list = [];
      }
    });
  }
}
